@ECHO Off
cls
SETLOCAL ENABLEEXTENSIONS
color 1f
echo.

call :check_Permissions
if "%ADMIN%"=="FAIL" goto :EOF

pushd "%~dp0"
if exist "%systemdrive%\Program Files\RMPrepusb\RMPartusb.exe"  pushd "%systemdrive%\Program Files\RMPrepusb"
if exist "%systemdrive%\Program Files (x86)\RMPrepusb\RMPartusb.exe" pushd "%systemdrive%\Program Files (x86)\RMPrepusb"
if not exist RMPARTUSB.exe echo Please install RMPrepUSB to the standard Program Files location & echo OR copy RMPartUSB.exe to %~dp0! & pause & goto :end

echo %~n0 [SSi] v1.00
echo.

echo SELECT A USB DRIVE
echo ==================
echo.
rmpartusb LIST | find "DRIVE"
echo.
set DD=
set /P DD=Please enter the USB drive number: 
set /a DD=DD
if "%DD%"=="" goto :end
if "%DD%"=="0" goto :end

set LBA=30
set MBR=
set PTN=
call :getsec
if "%MBR%%PTN%"=="11" goto :gotsec

set LBA=60
set MBR=
set PTN=
call :getsec
if "%MBR%%PTN%"=="11" goto :gotsec

set LBA=1
set MBR=
set PTN=
call :getsec
if "%MBR%%PTN%"=="11" goto :gotsec
echo No backup MBR found! & pause & goto :end


:gotsec
RMPARTUSB drive^=%DD% usbinfo usbstart^=%LBA% LENGTH=1SEC sure
echo Found backup MBR at SECTOR %LBA%
echo.
set ask=
set /p ask=OK to restore this MBR to DRIVE %DD% ([N]\Y) : 
if /i not "%ask%"=="Y" goto :end

:: MUST NOT USE USB drive to store .TMP file as RMPartUSB cannot access it after dismounting the volume!

:: Save LBA 0 to E2B0.TMP
RMPARTUSB USBTOFILE drive=%DD% FILE="%TEMP%\E2B0.TMP" USBSTART=0 LENGTH=1SEC FILESTART=0 SURE > nul

RMPARTUSB USBTOFILE drive=%DD% FILE="%TEMP%\E2B%LBA%.TMP" USBSTART=%LBA% LENGTH=1SEC FILESTART=0 SURE > nul
if errorlevel 1 goto :end
RMPARTUSB FILETOUSB drive=%DD% FILE="%TEMP%\E2B%LBA%.TMP" USBSTART=0  LENGTH=1SEC FILESTART=0 > nul
if errorlevel 1 goto :end
echo MBR Restored OK
pause

:end
popd
endlocal
GOTO :EOF


:getsec
FOR /F "tokens=16,17 delims=- " %%A IN ('RMPARTUSB drive^=%DD% usbinfo usbstart^=%LBA% length=1sec sure`^| FIND "01F0"') DO (
if "*%%A*%%B*"=="*55*AA*" echo Found MBR & set MBR=1
)
FOR /F "tokens=4 delims=- " %%A IN ('RMPARTUSB drive^=%DD% usbinfo usbstart^=%LBA% length=1sec sure`^| FIND "01C0"') DO (
if not "*%%A*"=="00" echo Found Partition 1 Entry & set PTN=1
)

goto :eof

:check_Permissions
    >nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
	REM --> If error flag set, we do not have admin.
	if '%errorlevel%' NEQ '0' (
        echo.
	echo Sorry - you need to run this script as Administrator.
        echo.
	echo Please use right-click - Run as administrator.
	echo.
	echo.
	color cf
	pause
	Set ADMIN=FAIL
    ) else (
	echo Administrative permissions confirmed.
    )

