@echo off
REM Edit this line to run your particular CONFIG FILE
set CONFIG=SDI_CHOCO.cmd
pushd "%~dp0"
if exist MyConfig.cmd call MyConfig.cmd
if exist \MyConfig.cmd call \MyConfig.cmd

title %~0   CONFIG FILE=%CONFIG%
echo Stage2 running >> %systemdrive%\Stage2.txt
REM Make current drive this drive

echo Stage2 running...


REM Switch our E2B drive back to E2B mode
if not exist \DRIVERS\e2b\FindCSMandRestoreE2B.cmd echo ERROR: Cannot find \DRIVERS\e2b\FindCSMandRestoreE2B.cmd & pause
call \DRIVERS\e2b\FindCSMandRestoreE2B.cmd SURE
echo This drive is %~d0
timeout 10

REM find E2B drive in case given different drive letter
set USBDRIVE=
FOR %%D IN (C D E F G H I J K L M N O P Q R S T U V W X Y Z) DO (
DIR %%D:\_ISO\e2b\grub\e2b.cfg  > nul 2>&1 && (call set USBDRIVE=%%D:) && echo FOUND %%D:\_ISO\e2b\grub\e2b.cfg && goto :found
)
:found

echo Found E2B drive at %USBDRIVE%
pushd %USBDRIVE%\

REM Now transfer to main file
if not exist %USBDRIVE%\_ISO\WINDOWS\INSTALLS\CONFIGS\%CONFIG% set CONFIG=%CONFIG%.cmd & echo INFO: %USBDRIVE%\_ISO\WINDOWS\INSTALLS\CONFIGS\%CONFIG% does not exist
if not exist %USBDRIVE%\_ISO\WINDOWS\INSTALLS\CONFIGS\%CONFIG% echo ERROR: %USBDRIVE%\_ISO\WINDOWS\INSTALLS\CONFIGS\%CONFIG% does not exist & pause

%USBDRIVE%\_ISO\WINDOWS\INSTALLS\CONFIGS\%CONFIG%


